<template>

        <div class="row">
            <div class='products'>
                <template v-if='productsData.data && productsData.data.length > 0' >
                    <div v-for='product in productsData.data' track-by='$index' :class="['product', product.slug] ">
                        <div @click.prevent="showProductDetail(product)" class='image' :style="{ backgroundImage: 'url(' + product.display_image + ')' }" style='background-size: cover; background-position: center;'></div>
                        <div @click.prevent="showProductDetail(product)" class='name'>{{ product.title }}</div>

                        <div class="row">
                            <div class='col-md price'>
                                <svg class="svg-icon-price green" viewBox="0 0 289.01202392578125 402.0111083984375" >
                                    <path d="M279.007 335.992l10.005 45.998c0 2.673-.348 4.67-1.004 6-1.34 2.673-3 4.004-4.997 4.004l-2.007.994c-.665 0-1.669.348-3 1.003-1.34 0-2.673.348-4.004 1.004-.665 0-1.669.348-3 1.003-1.34.666-2.345 1.004-3 1.004-1.34 0-2.846.174-4.495.502-1.669.348-2.846.502-3.502.502-.665 0-1.843.174-3.502.502-1.669.348-3.174.502-4.495.502-1.34.665-3 1.168-4.997 1.495-1.997.348-3.666.502-4.997.502-4.004 0-7.342.348-10.005 1.004h-10.998c-44 0-82.995-12.33-117.002-36.997-33.34-25.334-56.002-59.003-68.004-100.997H9.001c-2.673 0-4.997-1.004-7.004-3-1.34-1.331-1.997-3.328-1.997-6v-32c0-1.997.656-4.332 1.997-7.004 1.331-1.331 3.656-1.997 7.004-1.997h18.995c-1.34-11.325-1.34-21.33 0-30.003H9.001c-2.673 0-4.997-1.004-7.004-3C.657 178.36 0 176.016 0 174.009v-32c0-1.997.656-4.332 1.997-7.004 2.652-1.331 4.997-1.997 7.004-1.997h27.996c12.656-39.332 35.656-71.66 68.997-97.004C139.991 12.002 178.319 0 220.989 0c19.333 0 37.653 1.997 55 6 2.651 1.342 4.658 2.673 6 4.005.654 1.997 1.003 4.342 1.003 7.004l-12 45.998c-1.342 2.673-2.674 4.342-4.005 4.997-2.673 1.997-4.997 2.345-7.004 1.003h-2.007c-1.34-.656-2.345-1.003-3-1.003L249.979 67c-1.34 0-3.348-.327-6-1.003-2.673-.656-5.346-1.004-7.997-1.004-1.997 0-4.669-.327-7.997-1.003h-7.997c-24.003 0-45.67 6-65.004 18.002-19.344 13.343-33.669 30.34-42.998 50.995h134.001c2.652 0 4.997 1.004 7.004 3s2.652 4.67 1.997 7.998l-7.004 32c-1.34 5.345-4.342 7.998-9 7.998h-138.98c-1.34 7.342-1.34 17.346 0 30.003h131c2.652 0 4.997 1.003 7.004 3 1.331 1.34 1.997 4.004 1.997 7.997l-7.004 32c-1.34 2.673-2.345 4.342-3 4.997-2.673 1.34-4.669 1.997-6 1.997h-111c10.66 22.672 24.995 40.346 42.997 53.002 19.333 13.342 41.001 19.998 65.004 19.998 4.66 0 8.325-.327 10.998-1.003 4.004 0 7.004-.327 9.001-1.004.655 0 1.997-.154 4.004-.502 1.997-.327 3.655-.502 4.997-.502.655 0 1.833-.154 3.502-.502 1.66-.327 2.826-.502 3.502-.502.655 0 1.495-.327 2.5-1.003 1.003-.656 1.832-1.004 2.498-1.004l3-1.003h1.997c1.997-1.331 4.332-1.331 7.004 0 2.007 1.382 3.655 3.389 5.008 6.04z"></path>
                                </svg>
                                {{ product.price_discount }}
                            </div>
                            <div class="col-md price-prev">
                                <del v-if="product.price_previous" class="align-text-top">
                                    <svg class="svg-icon-prev-price grey" viewBox="0 0 289.01202392578125 402.0111083984375" >
                                        <path d="M279.007 335.992l10.005 45.998c0 2.673-.348 4.67-1.004 6-1.34 2.673-3 4.004-4.997 4.004l-2.007.994c-.665 0-1.669.348-3 1.003-1.34 0-2.673.348-4.004 1.004-.665 0-1.669.348-3 1.003-1.34.666-2.345 1.004-3 1.004-1.34 0-2.846.174-4.495.502-1.669.348-2.846.502-3.502.502-.665 0-1.843.174-3.502.502-1.669.348-3.174.502-4.495.502-1.34.665-3 1.168-4.997 1.495-1.997.348-3.666.502-4.997.502-4.004 0-7.342.348-10.005 1.004h-10.998c-44 0-82.995-12.33-117.002-36.997-33.34-25.334-56.002-59.003-68.004-100.997H9.001c-2.673 0-4.997-1.004-7.004-3-1.34-1.331-1.997-3.328-1.997-6v-32c0-1.997.656-4.332 1.997-7.004 1.331-1.331 3.656-1.997 7.004-1.997h18.995c-1.34-11.325-1.34-21.33 0-30.003H9.001c-2.673 0-4.997-1.004-7.004-3C.657 178.36 0 176.016 0 174.009v-32c0-1.997.656-4.332 1.997-7.004 2.652-1.331 4.997-1.997 7.004-1.997h27.996c12.656-39.332 35.656-71.66 68.997-97.004C139.991 12.002 178.319 0 220.989 0c19.333 0 37.653 1.997 55 6 2.651 1.342 4.658 2.673 6 4.005.654 1.997 1.003 4.342 1.003 7.004l-12 45.998c-1.342 2.673-2.674 4.342-4.005 4.997-2.673 1.997-4.997 2.345-7.004 1.003h-2.007c-1.34-.656-2.345-1.003-3-1.003L249.979 67c-1.34 0-3.348-.327-6-1.003-2.673-.656-5.346-1.004-7.997-1.004-1.997 0-4.669-.327-7.997-1.003h-7.997c-24.003 0-45.67 6-65.004 18.002-19.344 13.343-33.669 30.34-42.998 50.995h134.001c2.652 0 4.997 1.004 7.004 3s2.652 4.67 1.997 7.998l-7.004 32c-1.34 5.345-4.342 7.998-9 7.998h-138.98c-1.34 7.342-1.34 17.346 0 30.003h131c2.652 0 4.997 1.003 7.004 3 1.331 1.34 1.997 4.004 1.997 7.997l-7.004 32c-1.34 2.673-2.345 4.342-3 4.997-2.673 1.34-4.669 1.997-6 1.997h-111c10.66 22.672 24.995 40.346 42.997 53.002 19.333 13.342 41.001 19.998 65.004 19.998 4.66 0 8.325-.327 10.998-1.003 4.004 0 7.004-.327 9.001-1.004.655 0 1.997-.154 4.004-.502 1.997-.327 3.655-.502 4.997-.502.655 0 1.833-.154 3.502-.502 1.66-.327 2.826-.502 3.502-.502.655 0 1.495-.327 2.5-1.003 1.003-.656 1.832-1.004 2.498-1.004l3-1.003h1.997c1.997-1.331 4.332-1.331 7.004 0 2.007 1.382 3.655 3.389 5.008 6.04z"></path>
                                    </svg>
                                    {{ product.price_previous }}
                                </del>
                            </div>
                        </div>
                        <wishlist
                                :user-id="userId"
                                :product="product"
                                :wishlist-data="wishlistData"
                                :wishlist-user-id="wishlistUserId"
                                :is-wish-list-catalog="isWishListCatalog"
                        ></wishlist>
                        <br><br>
                    </div>

                    <paginator :products-data="productsData"
                               @paginator:change-page="onChangePage"
                    ></paginator>
                </template>
                <template v-else>
                    <div>
                        <h3>Product list empty</h3>
                    </div>
                </template>


            </div>
        </div>

</template>
<script>
    import Paginator from "./Paginator.vue";

    export default {
        components: {Paginator},
        name: 'products',
        props: {
            userId:{
                type: Number,
                default: null
            },
            productsData:{
                default: null
            },
            wishlistData:{
                default: null
            },
            isWishListCatalog:{
                type: Boolean,
                default: false
            },
            wishlistUserId: {
                type: Number,
                default: null
            },
        },

        data: function() {
            return {
                showModal: false,
                modalData: {},
                modalAmount: 1,
                timeout: "",
                mousestop: "",

            }
        },

        methods: {
            showProductDetail: function(product){
                this.$parent.switchToProductDetail(product);
            },

            onChangePage:function (page) {
                if(this.$parent.wishlistUserId) {
                    this.$parent.fetchWishlistData(page);
                }else{
                    this.$parent.fetchCatalogData(page);
                }
            }
        }
    }
</script>
<style>
    .svg-icon{
        width: 1rem;
    }
    .svg-icon-prev-price{
        width: 0.6rem;
    }
    .green{
        fill: green;
    }
    .grey{
        fill: grey;
    }
    .svg-icon-price{
        width:0.7rem;
    }
    .price-prev{
        font-weight: bold;
        font-size: 1rem;
        color: grey;
    }
</style>